diff --git a/src/gui/painting/qdrawhelper.cpp b/src/gui/painting/qdrawhelper.cpp
index e46e997..76a5dfb 100644
--- a/src/gui/painting/qdrawhelper.cpp
+++ b/src/gui/painting/qdrawhelper.cpp
@@ -3285,6 +3474,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchUntransformed64,         // A2RGB30_Premultiplied
         fetchUntransformed64,         // Alpha8
         fetchUntransformed64,         // Grayscale8
+        fetchUntransformedRGBA64PM,   // RGBX64
+        fetchUntransformed64,         // RGBA64
+        fetchUntransformedRGBA64PM,   // RGBA64_Premultiplied
     },
     // Transformed
     {
@@ -3313,6 +3505,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformed64<BlendTransformed>,         // A2RGB30_Premultiplied
         fetchTransformed64<BlendTransformed>,         // Alpah8
         fetchTransformed64<BlendTransformed>,         // Grayscale8
+        fetchTransformed64<BlendTransformed>,
+        fetchTransformed64<BlendTransformed>,
+        fetchTransformed64<BlendTransformed>,
     },
     {
         0, // TransformedTiled
@@ -3340,6 +3535,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformed64<BlendTransformedTiled>,            // A2RGB30_Premultiplied
         fetchTransformed64<BlendTransformedTiled>,            // Alpha8
         fetchTransformed64<BlendTransformedTiled>,            // Grayscale8
+        fetchTransformed64<BlendTransformedTiled>,
+        fetchTransformed64<BlendTransformedTiled>,
+        fetchTransformed64<BlendTransformedTiled>,
     },
     {
         0, // Bilinear
@@ -3367,6 +3565,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformedBilinear64<BlendTransformedBilinear>,         // A2RGB30_Premultiplied
         fetchTransformedBilinear64<BlendTransformedBilinear>,         // Alpha8
         fetchTransformedBilinear64<BlendTransformedBilinear>,         // Grayscale8
+        fetchTransformedBilinear64<BlendTransformedBilinear>,
+        fetchTransformedBilinear64<BlendTransformedBilinear>,
+        fetchTransformedBilinear64<BlendTransformedBilinear>,
     },
     {
         0, // BilinearTiled
@@ -3394,6 +3595,9 @@ static SourceFetchProc64 sourceFetch64[NBlendTypes][QImage::NImageFormats] = {
         fetchTransformedBilinear64<BlendTransformedBilinearTiled>,            // A2RGB30_Premultiplied
         fetchTransformedBilinear64<BlendTransformedBilinearTiled>,            // Alpha8
         fetchTransformedBilinear64<BlendTransformedBilinearTiled>,            // Grayscale8
+        fetchTransformedBilinear64<BlendTransformedBilinearTiled>,
+        fetchTransformedBilinear64<BlendTransformedBilinearTiled>,
+        fetchTransformedBilinear64<BlendTransformedBilinearTiled>,
     },
 };
 
@@ -3866,7 +4070,8 @@ void blend_color_generic_rgb64(int count, const QSpan *spans, void *userData)
             int l = qMin(buffer_size, length);
             QRgba64 *dest = op.destFetch64(buffer, data->rasterBuffer, x, spans->y, l);
             op.funcSolid64(dest, l, color, spans->coverage);
-            op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
+            if (op.destStore64)
+                op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
             length -= l;
             x += l;
         }
@@ -4055,7 +4260,7 @@ public:
 
     bool isSupported() const
     {
-        return op.func64 && op.destFetch64 && op.destStore64;
+        return op.func64 && op.destFetch64;
     }
 
     const QRgba64 *fetch(int x, int y, int len)
@@ -4071,7 +4276,8 @@ public:
 
     void store(int x, int y, int len)
     {
-        op.destStore64(data->rasterBuffer, x, y, dest, len);
+        if (op.destStore64)
+            op.destStore64(data->rasterBuffer, x, y, dest, len);
     }
 };
 
@@ -4178,7 +4384,8 @@ static void blend_untransformed_generic_rgb64(int count, const QSpan *spans, voi
                     const QRgba64 *src = op.srcFetch64(src_buffer, &op, data, sy, sx, l);
                     QRgba64 *dest = op.destFetch64(buffer, data->rasterBuffer, x, spans->y, l);
                     op.func64(dest, src, l, coverage);
-                    op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
+                    if (op.destStore64)
+                        op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
                     x += l;
                     sx += l;
                     length -= l;
@@ -4422,7 +4629,8 @@ static void blend_tiled_generic_rgb64(int count, const QSpan *spans, void *userD
             const QRgba64 *src = op.srcFetch64(src_buffer, &op, data, sy, sx, l);
             QRgba64 *dest = op.destFetch64(buffer, data->rasterBuffer, x, spans->y, l);
             op.func64(dest, src, l, coverage);
-            op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
+            if (op.destStore64)
+                op.destStore64(data->rasterBuffer, x, spans->y, dest, l);
             x += l;
             sx += l;
             length -= l;
@@ -5309,6 +5517,9 @@ static const ProcessSpans processTextureSpans[NBlendTypes][QImage::NImageFormats
         blend_untransformed_generic_rgb64,
         blend_untransformed_generic,
         blend_untransformed_generic,
+        blend_untransformed_generic_rgb64,
+        blend_untransformed_generic_rgb64,
+        blend_untransformed_generic_rgb64,
     },
     // Tiled
     {
@@ -5337,6 +5548,9 @@ static const ProcessSpans processTextureSpans[NBlendTypes][QImage::NImageFormats
         blend_tiled_generic_rgb64,
         blend_tiled_generic,
         blend_tiled_generic,
+        blend_tiled_generic_rgb64,
+        blend_tiled_generic_rgb64,
+        blend_tiled_generic_rgb64,
     },
     // Transformed
     {
@@ -5365,6 +5579,9 @@ static const ProcessSpans processTextureSpans[NBlendTypes][QImage::NImageFormats
         blend_src_generic_rgb64,
         blend_src_generic,
         blend_src_generic,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
     },
      // TransformedTiled
     {
@@ -5392,6 +5609,9 @@ static const ProcessSpans processTextureSpans[NBlendTypes][QImage::NImageFormats
         blend_src_generic_rgb64,
         blend_src_generic,
         blend_src_generic,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
     },
     // Bilinear
     {
@@ -5420,6 +5640,9 @@ static const ProcessSpans processTextureSpans[NBlendTypes][QImage::NImageFormats
         blend_src_generic_rgb64,
         blend_src_generic,
         blend_src_generic,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
+        blend_src_generic_rgb64,
     },
     // BilinearTiled
     {
@@ -5448,6 +5671,9 @@ static const ProcessSpans processTextureSpans[NBlendTypes][QImage::NImageFormats
         blend_src_generic_rgb64, // A2RGB30_Premultiplied
         blend_src_generic, // Alpha8
         blend_src_generic, // Grayscale8
+        blend_src_generic_rgb64, // RGBX64
+        blend_src_generic_rgb64, // RGBA64
+        blend_src_generic_rgb64, // RGBA64_Premultiplied
     }
 };
 
@@ -6014,6 +6240,14 @@ static void qt_rectfill_gray(QRasterBuffer *rasterBuffer,
                          qGray(color.toArgb32()), x, y, width, height, rasterBuffer->bytesPerLine());
 }
 
+static void qt_rectfill_rgb64(QRasterBuffer *rasterBuffer,
+                              int x, int y, int width, int height,
+                              const QRgba64 &color)
+{
+    qt_rectfill<quint64>(reinterpret_cast<quint64 *>(rasterBuffer->buffer()),
+                         color, x, y, width, height, rasterBuffer->bytesPerLine());
+}
+
 // Map table for destination image format. Contains function pointers
 // for blends of various types unto the destination
 
@@ -6212,6 +6446,26 @@ DrawHelper qDrawHelper[QImage::NImageFormats] =
         0, 0, 0,
         qt_rectfill_gray
     },
+    // Format_RGBX64
+    {
+        blend_color_generic_rgb64,
+        blend_src_generic_rgb64,
+        0, 0, 0,
+        qt_rectfill_rgb64
+    },
+    // Format_RGBA64
+    {
+        blend_color_generic_rgb64,
+        blend_src_generic_rgb64,
+        0, 0, 0, 0
+    },
+    // Format_RGBA64_Premultiplied
+    {
+        blend_color_generic_rgb64,
+        blend_src_generic_rgb64,
+        0, 0, 0,
+        qt_rectfill_rgb64
+    },
 };
 
 #if defined(Q_CC_MSVC) && !defined(_MIPS_)
diff --git a/src/gui/painting/qdrawhelper_p.h b/src/gui/painting/qdrawhelper_p.h
index f8865a6..fb9498e 100644
--- a/src/gui/painting/qdrawhelper_p.h
+++ b/src/gui/painting/qdrawhelper_p.h
@@ -1025,8 +1025,14 @@ inline int qBlue565(quint16 rgb) {
 
 static Q_ALWAYS_INLINE const uint *qt_convertARGB32ToARGB32PM(uint *buffer, const uint *src, int count)
 {
-    for (int i = 0; i < count; ++i)
-        buffer[i] = qPremultiply(src[i]);
+    // We explicitly split the aliased case to force the compiler to make optimized code paths for each case.
+    if (buffer == src) {
+        for (int i = 0; i < count; ++i)
+            buffer[i] = qPremultiply(buffer[i]);
+    } else {
+        for (int i = 0; i < count; ++i)
+            buffer[i] = qPremultiply(src[i]);
+    }
     return buffer;
 }
 
@@ -1037,6 +1043,7 @@ static Q_ALWAYS_INLINE const uint *qt_convertRGBA8888ToARGB32PM(uint *buffer, co
     return buffer;
 }
 
+template<bool RGBA> void qt_convertRGBA64ToARGB32(uint *dst, const QRgba64 *src, int count);
 
 const uint qt_bayer_matrix[16][16] = {
     { 0x1, 0xc0, 0x30, 0xf0, 0xc, 0xcc, 0x3c, 0xfc,
@@ -1104,7 +1111,7 @@ inline int comp_func_Plus_one_pixel(uint d, const uint s)
 struct QPixelLayout;
 typedef const uint *(QT_FASTCALL *ConvertFunc)(uint *buffer, const uint *src, int count,
                                                const QPixelLayout *layout, const QRgb *clut);
-typedef const QRgba64 *(QT_FASTCALL *ConvertFunc64)(QRgba64 *buffer, const uint *src, int count,
+typedef const QRgba64 *(QT_FASTCALL *ConvertFunc64)(QRgba64 *buffer, const quint64 *src, int count,
                                                     const QPixelLayout *layout, const QRgb *clut);
 
 struct QPixelLayout
@@ -1118,6 +1125,7 @@ struct QPixelLayout
         BPP16,
         BPP24,
         BPP32,
+        BPP64,
         BPPCount
     };
 
@@ -1135,17 +1143,20 @@ struct QPixelLayout
     ConvertFunc convertToARGB32PM;
     ConvertFunc convertFromARGB32PM;
     ConvertFunc convertFromRGB32;
-    ConvertFunc64 convertToARGB64PM;
+    ConvertFunc64 convertToRGBA64PM;
 };
 
 typedef const uint *(QT_FASTCALL *FetchPixelsFunc)(uint *buffer, const uchar *src, int index, int count);
 typedef void (QT_FASTCALL *StorePixelsFunc)(uchar *dest, const uint *src, int index, int count);
 
-extern QPixelLayout qPixelLayouts[QImage::NImageFormats];
-extern FetchPixelsFunc qFetchPixels[QPixelLayout::BPPCount];
-extern StorePixelsFunc qStorePixels[QPixelLayout::BPPCount];
-
+typedef const quint64 *(QT_FASTCALL *FetchPixelsFunc64)(quint64 *buffer, const uchar *src, int index, int count);
+typedef void (QT_FASTCALL *StorePixelsFunc64)(uchar *dest, const quint64 *src, int index, int count);
 
+extern QPixelLayout qPixelLayouts[QImage::NImageFormats];
+extern const FetchPixelsFunc qFetchPixels[QPixelLayout::BPPCount];
+extern const StorePixelsFunc qStorePixels[QPixelLayout::BPPCount];
+extern const FetchPixelsFunc64 qFetchPixels64[QPixelLayout::BPPCount];
+extern const StorePixelsFunc64 qStorePixels64[QPixelLayout::BPPCount];
 
 QT_END_NAMESPACE
 
diff --git a/src/gui/painting/qmemrotate.cpp b/src/gui/painting/qmemrotate.cpp
index f205cb1..105bc2a 100644
--- a/src/gui/painting/qmemrotate.cpp
+++ b/src/gui/painting/qmemrotate.cpp
@@ -465,9 +465,7 @@ Q_GUI_EXPORT void qt_memrotate270(const type *src, int w, int h, int sstride, \
     qt_memrotate270_tiled_unpacked<type>(src, w, h, sstride, dest, dstride); \
 }
 
-
-
-
+QT_IMPL_MEMROTATE(quint64)
 QT_IMPL_MEMROTATE(quint32)
 QT_IMPL_MEMROTATE(quint16)
 QT_IMPL_MEMROTATE(quint24)
@@ -518,6 +516,21 @@ void qt_memrotate270_32(const uchar *srcPixels, int w, int h, int sbpl, uchar *d
     qt_memrotate270((const uint *)srcPixels, w, h, sbpl, (uint *)destPixels, dbpl);
 }
 
+void qt_memrotate90_64(const uchar *srcPixels, int w, int h, int sbpl, uchar *destPixels, int dbpl)
+{
+    qt_memrotate90((const quint64 *)srcPixels, w, h, sbpl, (quint64 *)destPixels, dbpl);
+}
+
+void qt_memrotate180_64(const uchar *srcPixels, int w, int h, int sbpl, uchar *destPixels, int dbpl)
+{
+    qt_memrotate180((const quint64 *)srcPixels, w, h, sbpl, (quint64 *)destPixels, dbpl);
+}
+
+void qt_memrotate270_64(const uchar *srcPixels, int w, int h, int sbpl, uchar *destPixels, int dbpl)
+{
+    qt_memrotate270((const quint64 *)srcPixels, w, h, sbpl, (quint64 *)destPixels, dbpl);
+}
+
 MemRotateFunc qMemRotateFunctions[QImage::NImageFormats][3] =
 // 90, 180, 270
 {
@@ -546,6 +559,9 @@ MemRotateFunc qMemRotateFunctions[QImage::NImageFormats][3] =
     { qt_memrotate90_32, qt_memrotate180_32, qt_memrotate270_32 },      // Format_A2RGB30_Premultiplied,
     { qt_memrotate90_8, qt_memrotate180_8, qt_memrotate270_8 },         // Format_Alpha8,
     { qt_memrotate90_8, qt_memrotate180_8, qt_memrotate270_8 },         // Format_Grayscale8,
+    { qt_memrotate90_64, qt_memrotate180_64, qt_memrotate270_64 },      // Format_RGBX64
+    { qt_memrotate90_64, qt_memrotate180_64, qt_memrotate270_64 },      // Format_RGBA64
+    { qt_memrotate90_64, qt_memrotate180_64, qt_memrotate270_64 },      // Format_RGBA64_Premultiplied
 };
 
 QT_END_NAMESPACE
diff --git a/src/gui/painting/qmemrotate_p.h b/src/gui/painting/qmemrotate_p.h
index ece6e94..3d209e3 100644
--- a/src/gui/painting/qmemrotate_p.h
+++ b/src/gui/painting/qmemrotate_p.h
@@ -71,6 +71,7 @@ QT_DECL_MEMROTATE(quint32);
 QT_DECL_MEMROTATE(quint16);
 QT_DECL_MEMROTATE(quint24);
 QT_DECL_MEMROTATE(quint8);
+QT_DECL_MEMROTATE(quint64);
 
 #undef QT_DECL_MEMROTATE
 
diff --git a/tests/auto/gui/image/qimage/tst_qimage.cpp b/tests/auto/gui/image/qimage/tst_qimage.cpp
index 5691a65..511963e 100644
--- a/tests/auto/gui/image/qimage/tst_qimage.cpp
+++ b/tests/auto/gui/image/qimage/tst_qimage.cpp
@@ -184,6 +184,10 @@ private slots:
 
     void devicePixelRatio();
 
+    void metadataPassthrough();
+
+    void myTests();
+
 private:
     const QString m_prefix;
 };
@@ -2800,6 +2804,35 @@ void tst_QImage::cleanupFunctions()
 
 }
 
+void tst_QImage::myTests()
+{
+    
+    QImage image(900, 100, QImage::Format_RGBX64);
+    QPainter painter(&image);
+    QLinearGradient g(0, 0, 900, 0);
+    g.setColorAt(0, QColor("#FFCC22"));
+    g.setColorAt(1, QColor("#EE0033"));
+    QBrush brush(g);
+    painter.fillRect(QRect(0, 0, 900, 100), brush);
+    painter.end();
+    image.save("test64x.png");
+
+    QImage image2(900, 100, QImage::Format_RGB32);
+    QPainter painter2(&image2);
+    painter2.fillRect(QRect(0, 0, 900, 100), brush);
+    painter2.end();
+    image2.save("test32.png");
+    
+    QImage image3(900, 100, QImage::Format_RGB30);
+    QPainter painter3(&image3);
+    painter3.fillRect(QRect(0, 0, 900, 100), brush);
+    painter3.end();
+    image3.save("test30.png");
+
+    image3.convertToFormat(QImage::Format_RGBX64).save("test30x64.png");
+}
+
+
 // test image devicePixelRatio setting and detaching
 void tst_QImage::devicePixelRatio()
 {
@@ -2827,5 +2860,39 @@ void tst_QImage::devicePixelRatio()
     QCOMPARE(b.devicePixelRatio(), qreal(1.0));
 }
 
+void tst_QImage::metadataPassthrough()
+{
+    QImage a(64, 64, QImage::Format_ARGB32);
+    a.fill(Qt::white);
+    a.setText(QStringLiteral("Test"), QStringLiteral("Text"));
+    a.setDotsPerMeterX(100);
+    a.setDotsPerMeterY(80);
+    a.setDevicePixelRatio(2.0);
+
+    QImage scaled = a.scaled(QSize(32, 32), Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
+    QCOMPARE(scaled.text(QStringLiteral("Test")), a.text(QStringLiteral("Test")));
+    QCOMPARE(scaled.dotsPerMeterX(), a.dotsPerMeterX());
+    QCOMPARE(scaled.dotsPerMeterY(), a.dotsPerMeterY());
+    QCOMPARE(scaled.devicePixelRatio(), a.devicePixelRatio());
+
+    scaled = a.scaled(QSize(128, 128), Qt::IgnoreAspectRatio, Qt::FastTransformation);
+    QCOMPARE(scaled.text(QStringLiteral("Test")), a.text(QStringLiteral("Test")));
+    QCOMPARE(scaled.dotsPerMeterX(), a.dotsPerMeterX());
+    QCOMPARE(scaled.dotsPerMeterY(), a.dotsPerMeterY());
+    QCOMPARE(scaled.devicePixelRatio(), a.devicePixelRatio());
+
+    QImage mirrored = a.mirrored();
+    QCOMPARE(mirrored.text(QStringLiteral("Test")), a.text(QStringLiteral("Test")));
+    QCOMPARE(mirrored.dotsPerMeterX(), a.dotsPerMeterX());
+    QCOMPARE(mirrored.dotsPerMeterY(), a.dotsPerMeterY());
+    QCOMPARE(mirrored.devicePixelRatio(), a.devicePixelRatio());
+
+    QImage swapped = a.rgbSwapped();
+    QCOMPARE(swapped.text(QStringLiteral("Test")), a.text(QStringLiteral("Test")));
+    QCOMPARE(swapped.dotsPerMeterX(), a.dotsPerMeterX());
+    QCOMPARE(swapped.dotsPerMeterY(), a.dotsPerMeterY());
+    QCOMPARE(swapped.devicePixelRatio(), a.devicePixelRatio());
+}
+
 QTEST_GUILESS_MAIN(tst_QImage)
 #include "tst_qimage.moc"
diff --git a/tests/auto/gui/image/qimagewriter/tst_qimagewriter.cpp b/tests/auto/gui/image/qimagewriter/tst_qimagewriter.cpp
index 4f04e50..ecbab60 100644
--- a/tests/auto/gui/image/qimagewriter/tst_qimagewriter.cpp
+++ b/tests/auto/gui/image/qimagewriter/tst_qimagewriter.cpp
@@ -266,18 +266,16 @@ void tst_QImageWriter::writeImage2_data()
     QImage image0(70, 70, QImage::Format_ARGB32);
     image0.fill(QColor(Qt::red).rgb());
 
-    QImage::Format imgFormat = QImage::Format_Mono;
-    while (imgFormat != QImage::NImageFormats) {
-        QImage image = image0.convertToFormat(imgFormat);
+    for (int i = QImage::Format_Mono; i < QImage::NImageFormats; ++i) {
+        QImage image = image0.convertToFormat(QImage::Format(i));
         initializePadding(&image);
         foreach (const QString format, formats) {
-            const QString fileName = QString("solidcolor_%1.%2").arg(imgFormat)
+            const QString fileName = QString("solidcolor_%1.%2").arg(i)
                                      .arg(format);
             QTest::newRow(fileName.toLatin1()) << fileName
                                                << format.toLatin1()
                                                << image;
         }
-        imgFormat = QImage::Format(int(imgFormat) + 1);
     }
 }
 
